package com.nba.dmm;
import java.io.*;
import java.text.SimpleDateFormat;
import java.util.TimeZone;
import java.util.Date;
import java.util.Calendar;
import java.net.*;
import javax.crypto.*;
import javax.crypto.spec.*;
import org.apache.commons.codec.binary.Base64.*;

/**
 *
 * @author lchen
 */
public class basic {

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        String login = "user1";
        String keyTxt = "0123456789012345"; //128-bit key (16 characters)
        String requestURL = "http://vsserver2.nba-hq.com/Games?date=03/01/2013&league=nba";

        if (args.length == 3 && args[1].length() == 16 && args[2].startsWith("http://")) {

            login = args[0];
            keyTxt = args[1];
            requestURL = args[2];
        }
        SimpleDateFormat dateFormatGmt = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss'Z'");
        dateFormatGmt.setTimeZone(TimeZone.getTimeZone("GMT"));

        String text = dateFormatGmt.format(new Date());   //text to encode - should be current UTC time
        HttpURLConnection connection = null;

        try {
            //encryption
            byte[] key = keyTxt.getBytes("UTF-8");  //UTF-8 encoding
            byte[] iv = new byte[16];   //empty iv

            Cipher cipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
            cipher.init(Cipher.ENCRYPT_MODE, new SecretKeySpec(key, "AES"), new IvParameterSpec(iv));
            byte[] encrypted = cipher.doFinal(text.getBytes("UTF-8"));
            encrypted = org.apache.commons.codec.binary.Base64.encodeBase64(encrypted);
            System.out.println("Encrypted Signature is:  " + new String(encrypted, "UTF-8"));
       
            //create connection to URL
            URL URL = new URL(requestURL);
            connection = (HttpURLConnection) URL.openConnection();
            connection.setRequestMethod("GET"); //or POST
            String auth = "MEDIAARCHIVE " + login + ":" + new String(encrypted, "UTF-8");
            connection.setRequestProperty("Authorization", auth);
            connection.setUseCaches(false);
            connection.setDoInput(true);
            connection.setDoOutput(false);     //set to true for POST

            System.out.println("Authorization in header:  " + auth);            

           
            connection.connect();
            InputStream is = connection.getInputStream();
            BufferedReader rd = new BufferedReader(new InputStreamReader(is));
            String line;
            System.out.println("Response:  ");
            while ((line = rd.readLine()) != null) {
                System.out.println(line);
            }
        } catch (Exception e) {
            e.printStackTrace();
        } finally {
            if (connection != null) {
                connection.disconnect();
            }
        }
    }
}
